#!/usr/bin/perl
#
# dcnote-smil : 
#   SMIL, REALPIX ե
# Copyright (C) GFD_Dennou_Club, 2001.  All rights reserved.
#
#  Usage : dcreal-smil.pl 
#
#   2001/04/10 ̰ϯ;
#       2002/11/27 
#       2003/09/06 ̰ϯ
#
#   libjcode-pm-perl ɬ
######################################################################
#Jcode.pm ⥸塼ɤ߹
use Jcode; 

#ʸ
$target_code = "euc"; 

# եɤ߹
$CONF = 'dcreal.conf'; 
while (@ARGV) {
    last unless ($ARGV[0] =~ /^-/);
    $_ = shift;                           
    if (/^-c/) { $CONF = shift; next; }; 
    die "unknown option $_";
}
require "$CONF";

#realpix  bit per seconds
$BPS = 256000;

#ѤȤƻȤ빭׻
if ($OHPSW) {
    $WIDTH = $WIDTH_IMG + $WIDTH_RM; 
    if ($HEIGHT_IMG <= $HEIGHT_RM) {
	$HEIGHT = $HEIGHT_RM ;
    }else{
	$HEIGHT = $HEIGHT_IMG ;
    }
}else{
    $WIDTH = $WIDTH_RM;
    $HEIGHT = $HEIGHT_RM;
}

#Ǽǥ쥯ȥ
$RMDIR = "../$RMDIR"; 
$SMILDIR = "$RMDIR/smi";
$IMGDIR = "$RMDIR/img-real";

#ӥǥ񸻥ǥ쥯ȥ & 
unless (-d $RMDIR) {
    mkdir $RMDIR, 0777  ;
    $i = 0; 
    while ($TRT_FILES[$i]) {
	if ($RM_FILES[$i] !~ /^$/){
	    print "cd $RMDIR; ln -s ../$SRC/$RM_FILES[$i] ./ \n";
	    system("cd $RMDIR; ln -s ../$SRC/$RM_FILES[$i] ./");
	}
	$i++;
    }
}

#SMIL եǼǥ쥯ȥ
mkdir $SMILDIR, 0777  unless -d $SMILDIR ;

#եǼǥ쥯ȥ & 
if ($OHPSW){
    unless (-d $IMGDIR) {
	mkdir $IMGDIR, 0777; 
	system("cd $IMGDIR; ln -s ../../$IMGDIR_RM/* ./");
    }
}

#ߥ󥰥ե뤬¸ߤ뤫ǧ
foreach $TRT (@TRT_FILES) {
    unless (-f $TRT) {
	print "Not $TRT \n"; 
	exit 1;
    }
}

# RealPix ե̾
$i = 0;
while (@TRT_FILES[$i]) {
    $PIX_FILES[$i] = $RM_FILES[$i];
    $PIX_FILES[$i] =~ s/rm$/rp/;
    $i++; 
}
#print "@PIX_FILES \n";

#ߥ󥰥եΥץ, ɬפʾ. 
$i = 0; 
$e = 0;
while (@TRT_FILES[$e]) {
    open (TIMING, "$TRT_FILES[$e]");
    $start[$e] = $i; 
    while (<TIMING>) {
	chomp(@_);
	#ϻ, OHP ֹ, OHP ȥ̡¸
	$_ =~ /([0-9]+:[0-9]+:[0-9]+),(\d+):(.*)/;
	$time[$i] = $1;
	$ohp_num[$i] = $2;
	($code, $nmatch) = getcode($3);
#	print "$code, $nmatch \n"; 
	$ohp_title[$i] = Jcode::convert($3, $target_code, $code); 
	$end[$e] = $i; 
#	print "$time[$i], $ohp_num[$i], $ohp_title[$i] \n"; 
	$i++;
    }
    $e++;
    close (TIMING);
}
#print "@start, @end \n" ;

# SMIL եκ
$i = 0;
while ($ohp_num[$i]) {
    #ե̾ν
    $num = sprintf("%03d", $ohp_num[$i]);
    
    #˥ե뤬¸ߤʤΤ SMIL ե
    $SMIL = "$SMILDIR/$num.smi";
    
    $e = 0;
    while ($end[$e]) {
	if ($i >= $start[$e]) {
	    $RM_FILE = "$RM_FILES[$e]"; 
	    $PIX_FILE = "$PIX_FILES[$e]"; 
	}
	$e ++;
    }
    
    unless (-f $SMIL) {
	&print_smi($SMIL, $time[$i], $RM_FILE, $PIX_FILE);
    }  
    $i++;
}
#print "@ohp_num \n"; 

# RealPix եκ
if ($OHPSW) {
    $i = 0; 
    while ($TRT_FILES[$i]) {
	if ($PIX_FILES[$i] !~ /^$/){
	    &print_rp($PIX_FILES[$i], $RM_DURS[$i], $start[$i], $end[$i]);
	}
	$i++; 
    }
}
exit 0;

#=======================================================================


# SMIL եѥ֥롼
sub print_smi{
    my($smifile, $time, $RM, $PIX) = @_;
    open (SMIL, ">$smifile");

    #եؤν񤭽Ф. ꡹ѿ. 
    if ($OHPSW) {
	print SMIL <<EOT
<smil>
<head>
  <meta name="title" content="$TITLE_EN"/>
  <meta name="author" content="$NAME_EN"/>
  <meta name="copyright" content="$COPYRIGHT"/> 
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="rm" top="0" left="0" width="$WIDTH_RM" height="$HEIGHT_RM"/>
    <region id="pix" top="0" left="$WIDTH_RM" width="$WIDTH_IMG" height="$HEIGHT_IMG"/>
  </layout>
</head>
<body>
  <par>
     <seq>
       <video src="../$RM" region="rm" clip-begin="$time"/>
     </seq>
      <img src="../$PIX" region="pix" clip-begin="$time"/>
  </par>
</body>
</smil>
EOT
;
    }else{
	print SMIL <<EOT
<smil>
<head>
  <meta name="title" content="$TITLE_EN"/>
  <meta name="author" content="$NAME_EN"/>
  <meta name="copyright" content="$COPYRIGHT"/> 
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="rm" top="0" left="0" width="$WIDTH" height="$HEIGHT"/>
  </layout>
</head>
<body>
  <par>
     <seq>
       <video src="../$RM" region="rm" clip-begin="$time"/>
     </seq>
  </par>
</body>
</smil>
EOT
;
    }
    close (SMIL);
}


# RealPix ѥ֥롼
sub print_rp{
    my($PIX, $DUR, $s1, $s2) = @_;    
    open (RP, ">$RMDIR/$PIX");
    #إåκ
    print RP <<EOT1
<imfl>
<head width="$WIDTH_IMG" height="$HEIGHT" start="0" duration="$DUR" title="$TITLE_EN" bitrate="$BPS" timeformat="dd:hh:mm:ss.xyz"/>
EOT1
    ;
    
    #ϥɥκ. Ф̵ֹ
    foreach $n ($s1 .. $s2) {
	$l = 1; 
	foreach $m ($s1 .. $n - 1) {
	    if ($ohp_num[$n] == $ohp_num[$m]) {
		$l = 0; 
	    }
	}
	if ($l) {
	    $num = sprintf("%03d", $ohp_num[$n]);
	    print RP "<image handle=\"$ohp_num[$n]\" name=\"img-real/$num.$EXT\"/> \n";
	}
    }
    
#ǡν񤭽Ф
    print RP <<EOT2
<fill start="00:00:00" color="black"/>
<fadein start="00:00:00" duration="3" target="$ohp_num[$s1]"/>
EOT2
    ;
    
    foreach $n ($s1 + 1 .. $s2) { 
	$num = sprintf("%03d", $ohp_num[$n]);
	print RP "<wipe type=\"push\" direction=\"left\" start=\"$time[$n]\" duration=\"3\" target=\"$ohp_num[$n]\"/> \n";
    }
    print RP "</imfl> \n";
    close(RP);

}
